"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _geofeedValidator = _interopRequireDefault(require("geofeed-validator"));
var _ipSub = _interopRequireDefault(require("ip-sub"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function processPrefix(prefix) {
  if (prefix && (_ipSub["default"].isValidPrefix(prefix) || _ipSub["default"].isValidIP(prefix))) {
    var _ipUtils$getIpAndCidr = _ipSub["default"].getIpAndCidr(_ipSub["default"].toPrefix(prefix)),
      _ipUtils$getIpAndCidr2 = _slicedToArray(_ipUtils$getIpAndCidr, 2),
      ip = _ipUtils$getIpAndCidr2[0],
      cidr = _ipUtils$getIpAndCidr2[1];
    return "".concat(_ipSub["default"].expandIP(ip), "/").concat(cidr);
  }
  return null;
}
var Geofeed = exports["default"] = /*#__PURE__*/_createClass(function Geofeed(inetnum, prefix, country, region, city, zip) {
  var _this = this;
  _classCallCheck(this, Geofeed);
  _defineProperty(this, "validate", function () {
    return _geofeedValidator["default"].fromArray([_this.prefix, _this.country, _this.region, _this.city, _this.zip]);
  });
  _defineProperty(this, "toString", function () {
    return [_this.prefix, _this.country || "", _this.region || "", _this.city || "", _this.zip || ""].join(",").replace(/"/g, "");
  });
  this.inetnum = inetnum.toLowerCase();
  this.prefix = processPrefix(prefix);
  this.country = country ? country.toUpperCase().slice(0, 3) : null;
  this.region = region ? region.toUpperCase().slice(0, 7) : null;
  this.zip = zip ? zip.slice(20) : null;
  this.city = city ? city.slice(0, 100) : null;
  this.valid = true;
});